COMMENT ^
/*****************************************************************************/
/*--[drm5stub.asm]-------------------------------------------------------------
 | Copyright (C) 2002, 2003 Dan A. Jackson 
 |
 | This file is part of the "clit" (Convert LIT) program. 
 |
 | Convert LIT is free software; you can redistribute it and/or modify
 | it under the terms of the GNU General Public License as published by
 | the Free Software Foundation; either version 2 of the License, or
 | (at your option) any later version.
 |
 | This program is distributed in the hope that it will be useful,
 | but WITHOUT ANY WARRANTY; without even the implied warranty of
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 | GNU General Public License for more details.
 |
 | You should have received a copy of the GNU General Public License
 | along with this program; if not, write to the Free Software
 | Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 | 
 | The GNU General Public License may also be available at the following
 | URL: http://www.gnu.org/licenses/gpl.html
*/
^

.386
.MODEL FLAT
.CODE

PUBLIC  _stub_offset,_stub_size 

; 
; Parameters
;
;       FreeLibraryAndExitThread
;       offsetDone
;       offsetExec
;       offsetMap
;       GetProcAddress
;       LoadLibrary
;       offsetPath
;

_remote_stub    PROC
stub_begin      LABEL BYTE
        xor     ebp, ebp
        stc     
        sbb     edi, edi 
        ; LoadLibrary( offsetPath ) 
        call    DWORD PTR [esp+4]
        pop     ecx
        test    eax, eax
        jz      @f 
        mov     ebp, eax

        ; GetProcAddress( h, 1 );
        push    1
        push    ebp
        call    DWORD PTR [esp+8]
        test    eax, eax
        jz      @f

        ; Ord 1 from DRM5HOOK with the 3 offsets
        pop     ecx
        call    eax
        add     esp, 12
        mov     edi, eax

        ; FreeLibraryAndExitThread( h, Eax )
@@:
        push    edi
        push    ebp
        call    DWORD PTR [esp+8]
        ; Doesn't return
        int     3      
        xor     eax, eax
        jmp     eax 
_remote_stub     ENDP
stub_end        LABEL   BYTE

.DATA
_stub_offset DD  OFFSET stub_begin
_stub_size   DD  stub_end - stub_begin

END

